package org.objectweb.jinha.commands;

import java.util.Iterator;
import java.util.List;

import org.objectweb.jinha.model.CMPModel;
import org.objectweb.jinha.model.ListModel;
import org.objectweb.jinha.model.emf.jinha.GraphicalEntity;

import com.sun.java.xml.ns.j2ee.EntityBeanType;
import com.sun.java.xml.ns.j2ee.FullyQualifiedClassType;
import com.sun.java.xml.ns.j2ee.JavaIdentifierType;

/**
 * add a CMP field to a entity bean and the associated emf model
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class CreateCMPCommand extends MainCommand {

    private ListModel list;

    private CMPModel  newCMP;

    /**
     * @param list the list of CMP where will be added the newMethod
     * @param newMethod the CMP to be added
     */
    public CreateCMPCommand(ListModel list, CMPModel newMethod) {
        this.newCMP = newMethod;
        this.list = list;
    }

    /**
     * performs the operation of adding the CMP field to the ejb's list of CMP
     * @see org.eclipse.gef.commands.Command#execute()
     */
    public void execute() {
    	String ident=getIdent();

        newCMP.setIdentifier(ident);
        if(getCpt()==1){
        	newCMP.setIdentifier("PK_FIELD");
            EntityBeanType entityBean=((GraphicalEntity)list.getEjb()).getEntityBean().getEntityEjb();
        	newCMP.setPrimaryKey(true);
            com.sun.java.xml.ns.j2ee.String primaryKey = j2eeFactory.createString();
    		primaryKey.setValue(newCMP.getIdentifier());
    		entityBean.setPrimkeyField(primaryKey);
    		FullyQualifiedClassType primaryKeyClass = j2eeFactory.createFullyQualifiedClassType();
    		primaryKeyClass.setValue(newCMP.getReturnType());
    		entityBean.setPrimKeyClass(primaryKeyClass);
        }
        
        JavaIdentifierType fieldName = j2eeFactory.createJavaIdentifierType();
        fieldName.setValue(ident);
        newCMP.getFieldMapping().setFieldName(fieldName);
        
        JavaIdentifierType colName = j2eeFactory.createJavaIdentifierType();
        colName.setValue(ident);
        newCMP.getFieldMapping().setColumnName(colName);
        
            
        list.addElement(newCMP);
        if (list.getEjb() instanceof GraphicalEntity)
            ((GraphicalEntity) list.getEjb()).getEntityBean()
                    .getFieldMappings().add(newCMP.getFieldMapping());
    }

    /**
	 * @return
	 */
	private String getIdent() {
		String id="CMP"+getCpt();
		Iterator it=list.getElementList().iterator();
		while(it.hasNext()){
			if(id.equals(((CMPModel)it.next()).getIdentifier())){
				id+="_"+getCpt();
				it=list.getElementList().iterator();
			}
		}
		return id;
	}

	/**
     * performs execute()
     * @see org.eclipse.gef.commands.Command#redo()
     */
    public void redo() {
        execute();
    }

    /**
     * remove the CMP of the list
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo() {
        if (list.getEjb() instanceof GraphicalEntity)
            ((GraphicalEntity) list.getEjb()).getEntityBean()
                    .getFieldMappings().remove(newCMP.getFieldMapping());

        list.removeElement(newCMP);
    }
    
    public  int getCpt() {
        int cpt=0;
        List l=((GraphicalEntity)list.getEjb()).getEntityBean().getFieldMappings();
            
        
        Iterator i=l.iterator();
        while(i.hasNext()) {
            i.next();
            cpt++;
        }
        return cpt+1;
    }
}

