package org.objectweb.jinha.commands;

import org.objectweb.jinha.model.CMRModel;
import org.objectweb.jinha.model.ListModel;

/**
 * add a CMR field to a entity bean and the associated emf model
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class CreateCMRCommand extends MainCommand {

    private ListModel list;

    private CMRModel  newCMR;

    /**
     * @param list
     * @param newMethod
     */
    public CreateCMRCommand(ListModel list, CMRModel newMethod) {
        this.newCMR = newMethod;
        this.list = list;
    }

    /**
     * performs the operation of adding the CMR field to the ejb's list of CMR
     * @see org.eclipse.gef.commands.Command#execute()
     */
public void execute()
	{
		list.addElement(newCMR);
       // if(list.getEjb() instanceof GraphicalEntity)
       //     ((GraphicalEntity)list.getEjb()).getEntityBean().g
	}   



/**
 * performs execute()
 * @see org.eclipse.gef.commands.Command#redo()
 */
public void redo() {
        execute();
    }

    

    /**
     * remove the CMR of the list
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo() {
        list.removeElement(newCMR);
    }
}

