package org.objectweb.jinha.commands;

import org.objectweb.jinha.model.AttributeModel;
import org.objectweb.jinha.model.BusinessMethodModel;
import org.objectweb.jinha.model.HomeMethodModel;
import org.objectweb.jinha.model.ListModel;
import org.objectweb.jinha.model.emf.jinha.GraphicalSession;

/**
 * add an element (method, CMP, CMR..) to an ejb's list
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class ListElementAddCommand extends MainCommand {

    private Object    child;

    private Object    after;

    //private int indiceInsertion;
    private ListModel list;

    /**
     * @param list the list where will be added the object
     * @param child the element to be added
     * @param after the index of insertion in the list
     */
    public ListElementAddCommand(ListModel list, Object child, Object after) {
        this.child = child;
        this.after = after;
        this.list = list;
        /*
         * if(after == null) {//il faut insrer l'enfant  la fin
         * indiceInsertion = list. } else { int indexAfter =
         * list.getIndexOf(after); list.addElement(child, indexAfter); }
         */
    }

    /**
     * performs the insertion of the element in the list
     * @see org.eclipse.gef.commands.Command#execute()
     */
    public void execute() {
        if (after == null) {//il faut insrer l'enfant  la fin
            list.addElement(child);
        }
        else {
            int indexAfter = list.getIndexOf(after);
            list.addElement(child, indexAfter);
        }
        
        if(list.getEjb() instanceof GraphicalSession) {
            if(child instanceof AttributeModel)
                ((GraphicalSession)list.getEjb()).getSessionBean().getJavaAttributes().add(((AttributeModel)child).getAttribute());
            else if (child instanceof HomeMethodModel)
                ((GraphicalSession)list.getEjb()).getSessionBean().getMethods().add(((HomeMethodModel)child).getMethod());
            else if (child instanceof BusinessMethodModel)
                ((GraphicalSession)list.getEjb()).getSessionBean().getMethods().add(((BusinessMethodModel)child).getMethod());

        }
       /* else if(list.getEjb() instanceof GraphicalEntity) {
            if(child instanceof AttributeModel)
                ((GraphicalEntity)list.getEjb()).getEntityBean().getJavaAttributes().add(((AttributeModel)child).getAttribute());
            else if (child instanceof HomeMethodModel)
                ((GraphicalEntity)list.getEjb()).getEntityBean().getMethods().add(((HomeMethodModel)child).getMethod());
            else if (child instanceof BusinessMethodModel)
                ((GraphicalEntity)list.getEjb()).getEntityBean().getMethods().add(((BusinessMethodModel)child).getMethod());

        }
        else if(list.getEjb() instanceof GraphicalMessageDriven) {
            if(child instanceof AttributeModel)
                ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getJavaAttributes().add(((AttributeModel)child).getAttribute());
            else if (child instanceof HomeMethodModel)
                ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getMethods().add(((HomeMethodModel)child).getMethod());
            else if (child instanceof BusinessMethodModel)
                ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getMethods().add(((BusinessMethodModel)child).getMethod());

        }*/
        
        
    }

    /**
     * same as execute()
     * @see org.eclipse.gef.commands.Command#redo()
     */
    public void redo() {
        execute();
    }

    /**
     * delete the element from the list
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo() {
        list.removeElement(child);
        if(list.getEjb() instanceof GraphicalSession) {
            if(child instanceof AttributeModel)
                ((GraphicalSession)list.getEjb()).getSessionBean().getJavaAttributes().remove(((AttributeModel)child).getAttribute());
            else if (child instanceof HomeMethodModel)
                ((GraphicalSession)list.getEjb()).getSessionBean().getMethods().remove(((HomeMethodModel)child).getMethod());
            else if (child instanceof BusinessMethodModel)
                ((GraphicalSession)list.getEjb()).getSessionBean().getMethods().remove(((BusinessMethodModel)child).getMethod());

        }
       /* else if(list.getEjb() instanceof GraphicalEntity) {
            if(child instanceof AttributeModel)
                ((GraphicalEntity)list.getEjb()).getEntityBean().getJavaAttributes().remove(((AttributeModel)child).getAttribute());
            else if (child instanceof HomeMethodModel)
                ((GraphicalEntity)list.getEjb()).getEntityBean().getMethods().remove(((HomeMethodModel)child).getMethod());
            else if (child instanceof BusinessMethodModel)
                ((GraphicalEntity)list.getEjb()).getEntityBean().getMethods().remove(((BusinessMethodModel)child).getMethod());

        }
        else if(list.getEjb() instanceof GraphicalMessageDriven) {
            if(child instanceof AttributeModel)
                ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getJavaAttributes().remove(((AttributeModel)child).getAttribute());
            else if (child instanceof HomeMethodModel)
                ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getMethods().remove(((HomeMethodModel)child).getMethod());
            else if (child instanceof BusinessMethodModel)
                ((GraphicalMessageDriven)list.getEjb()).getMessageDrivenBean().getMethods().remove(((BusinessMethodModel)child).getMethod());

        }*/
    }
}