package org.objectweb.jinha.commands;

import org.objectweb.jinha.model.EntityModel;
import org.objectweb.jinha.model.RelationModel;

/**
 * reconnect a relation to a new ejb target 
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class ReconnectTargetCommand extends MainCommand {

    private EntityModel   newTarget;

    private EntityModel   oldTarget;

    private RelationModel connection;

    /**
     * @param newTarget the new ejb target
     * @param connection the relation
     */
    public ReconnectTargetCommand(EntityModel newTarget,
            RelationModel connection) {
        this.newTarget = newTarget;
        this.connection = connection;
    }

    /**
     * performs the change of ejb target
     * @see org.eclipse.gef.commands.Command#execute()
     */
    public void execute() {
        oldTarget = connection.getTarget();
        connection.setTarget(newTarget);
    }

    /**
     * same as execute()
     * @see org.eclipse.gef.commands.Command#redo()
     */
    public void redo() {
        connection.setTarget(newTarget);
    }

    /**
     * restore the old target ejb to the relation
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo() {
        connection.setTarget(oldTarget);
    }
}