package org.objectweb.jinha.editparts;
 
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.objectweb.jinha.figures.BusinessMethodListFigure;
import org.objectweb.jinha.model.BusinessMethodListModel;


/**
 *  the editpart for a business method list
 * catch event from the model and eventually represent it to the figure
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class BusinessMethodListEditPart extends ListEditPart {

    
    /**
     * @return the figure associated to a business method list
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     */
    public IFigure createFigure() {
        return new BusinessMethodListFigure();
    }

    /**
     * @return the lsit of children for a business method list
     * @see org.eclipse.gef.editparts.AbstractEditPart#getModelChildren()
     */
    public List getModelChildren() {
        return ((BusinessMethodListModel) getModel()).getElementList();
    }
}