package org.objectweb.jinha.editparts;
 
import java.beans.PropertyChangeEvent;

import org.eclipse.gef.EditPolicy;
import org.objectweb.jinha.editpolicies.ToolbarLayoutEditPolicyImpl;
import org.objectweb.jinha.model.ListModel;


/**
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */

public abstract class ListEditPart extends ObjectEditPart {

    
    /**
     * 
     * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
     */
    public void createEditPolicies() {
        super.createEditPolicies();
        installEditPolicy(EditPolicy.LAYOUT_ROLE,
                new ToolbarLayoutEditPolicyImpl());
    }

    
    /**
     * @param ev event sent by a list model
     * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
     */
    public void propertyChange(PropertyChangeEvent ev) {
        if (ev.getPropertyName().equals(ListModel.PROPERTY_LIST_MODIFIED))
            refreshChildren();
        super.propertyChange(ev);
    }
}