package org.objectweb.jinha.editparts;

import java.beans.PropertyChangeEvent;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.objectweb.jinha.editpolicies.EjbComponentEditPolicy;
import org.objectweb.jinha.figures.MessageDrivenFigure;
import org.objectweb.jinha.model.MessageDrivenModel;

public class MessageDrivenEditPart extends DiagramElementEditPart //implements NodeEditPart
{
	//private ChopboxAnchor anchor;
	
	public IFigure createFigure()
	{
		IFigure fig = new MessageDrivenFigure();
		//anchor = new ChopboxAnchor(fig);
		return fig;
	}
	public void refreshVisuals()
	{
		super.refreshVisuals();
		MessageDrivenFigure figure = (MessageDrivenFigure)getFigure();
		MessageDrivenModel model = (MessageDrivenModel)getModel();
		figure.setLabel(model.getName());
	}
	public List getModelChildren()
	{
		List children = new ArrayList();
		MessageDrivenModel model = (MessageDrivenModel)getModel();
		children.add(model.getAttributeList());
		children.add(model.getBusinessMethodList());
        children.add(model.getHomeMethods());
		return children;
	}
	/*public List getModelSourceConnections()
	{
		return ((MessageDrivenModel)getModel()).getSourceConnections();
	}
	public List getModelTargetConnections()
	{
		return ((MessageDrivenModel)getModel()).getTargetConnections();
	}*/
	public IFigure getContentPane()
	{
		return ((MessageDrivenFigure)getFigure()).getContentPane();
	}
	public BusinessMethodListEditPart getBusinessMethodListEditPart()
	{
		return (BusinessMethodListEditPart)getChildren().get(1);
	}
	public AttributeListEditPart getAttributeListEditPart()
	{
		return (AttributeListEditPart)getChildren().get(0);
	}
    public HomeMethodListEditPart getHomeMethodListEditPart()
    {
        return (HomeMethodListEditPart)getChildren().get(2);
    }
	public void propertyChange(PropertyChangeEvent ev)
	{
		if(ev.getPropertyName().equals(MessageDrivenModel.PROPERTY_NAME_CHANGED))
			refreshVisuals();
		else if(ev.getPropertyName().equals(MessageDrivenModel.PROPERTY_SOURCE_CONNECTIONS_CHANGED))
			refreshSourceConnections();
		else if(ev.getPropertyName().equals(MessageDrivenModel.PROPERTY_TARGET_CONNECTIONS_CHANGED))
			refreshTargetConnections();
			super.propertyChange(ev);
	}
	/*public ConnectionAnchor getSourceConnectionAnchor(ConnectionEditPart connection)
	{
		return anchor;
	}
	public ConnectionAnchor getTargetConnectionAnchor(ConnectionEditPart connection)
	{
		return anchor;
	}
	public ConnectionAnchor getSourceConnectionAnchor(Request request)
	{
		return anchor;
	}
	public ConnectionAnchor getTargetConnectionAnchor(Request request)
	{
		return anchor;
	}*/
	public void createEditPolicies()
	{
		super.createEditPolicies();
		//installEditPolicy(EditPolicy.NODE_ROLE, new GraphicalNodeEditPolicyImpl());
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new EjbComponentEditPolicy(){});
	}
}
