package org.objectweb.jinha.editparts;

import java.beans.PropertyChangeEvent;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.objectweb.jinha.editpolicies.EjbComponentEditPolicy;
import org.objectweb.jinha.figures.SessionFigure;
import org.objectweb.jinha.model.SessionModel;
import org.objectweb.jinha.model.properties.PropertyEjbBeanSession;

public class SessionEditPart extends DiagramElementEditPart // implements NodeEditPart
{
	//private ChopboxAnchor anchor;
	
	public IFigure createFigure()
	{
		IFigure fig = new SessionFigure();
	//	anchor = new ChopboxAnchor(fig);
		return fig;
	}
	public void refreshVisuals()
	{
		super.refreshVisuals();
		SessionFigure figure = (SessionFigure)getFigure();
		SessionModel model = (SessionModel)getModel();
		figure.setLabel(model.getPropertyEjbBeanSession().getEjbBeanName());
	}
	public List getModelChildren()
	{
		List children = new ArrayList();
		SessionModel model = (SessionModel)getModel();
		children.add(model.getAttributeList());
		children.add(model.getHomeMethods());
        children.add(model.getbusinessMethods());
		return children;
	}
    /*
	public List getModelSourceConnections()
	{
		return ((SessionModel)getModel()).getSourceConnections();
	}
	public List getModelTargetConnections()
	{
		return ((SessionModel)getModel()).getTargetConnections();
	}*/
	public IFigure getContentPane()
	{
		return ((SessionFigure)getFigure()).getContentPane();
	}
	public BusinessMethodListEditPart getBusinessMethodListEditPart()
	{
		return (BusinessMethodListEditPart)getChildren().get(2);
	}
	public AttributeListEditPart getAttributeListEditPart()
	{
		return (AttributeListEditPart)getChildren().get(0);
	}
    public HomeMethodListEditPart getHomeMethodListEditPart()
    {
        return (HomeMethodListEditPart)getChildren().get(1);
    }
	public void propertyChange(PropertyChangeEvent ev)
	{
		if(ev.getPropertyName().equals(PropertyEjbBeanSession.PROPERTY_NAME_CHANGED))
			refreshVisuals();
		/*else if(ev.getPropertyName().equals(SessionModel.PROPERTY_SOURCE_CONNECTIONS_CHANGED))
			refreshSourceConnections();
		else if(ev.getPropertyName().equals(SessionModel.PROPERTY_TARGET_CONNECTIONS_CHANGED))
			refreshTargetConnections();*/
			super.propertyChange(ev);
	}
	/*public ConnectionAnchor getSourceConnectionAnchor(ConnectionEditPart connection)
	{
		return anchor;
	}
	public ConnectionAnchor getTargetConnectionAnchor(ConnectionEditPart connection)
	{
		return anchor;
	}
	public ConnectionAnchor getSourceConnectionAnchor(Request request)
	{
		return anchor;
	}
	public ConnectionAnchor getTargetConnectionAnchor(Request request)
	{
		return anchor;
	}*/
	public void createEditPolicies()
	{
		super.createEditPolicies();
		//installEditPolicy(EditPolicy.NODE_ROLE, new GraphicalNodeEditPolicyImpl());
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new EjbComponentEditPolicy(){});
	}
    
    
    
    /**
     * 
     * @see org.eclipse.gef.EditPart#activate()
     */
    public void activate() {
        // TODO Auto-generated method stub
        
        if (!isActive()) {
            super.activate();
            (((SessionModel) getModel()).getPropertyEjbBeanSession()).addPropertyChangeListener(this);
        }
    }
    /**
     * 
     * @see org.eclipse.gef.EditPart#deactivate()
     */
    public void deactivate() {
        // TODO Auto-generated method stub
        super.deactivate();
        (((SessionModel) getModel()).getPropertyEjbBeanSession()).removePropertyChangeListener(this);
    }
}
