package org.objectweb.jinha.figures;

import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.swt.graphics.Image;

public class AttributeFigure extends Label {

    private static final Image IMAGE_PUBLIC    = new Image(
                                                       null,
                                                       EjbFigureBorder.class
                                                               .getResourceAsStream("field_public_obj.gif"));

    private static final Image IMAGE_PRIVATE   = new Image(
                                                       null,
                                                       EjbFigureBorder.class
                                                               .getResourceAsStream("field_private_obj.gif"));

    private static final Image IMAGE_PROTECTED = new Image(
                                                       null,
                                                       EjbFigureBorder.class
                                                               .getResourceAsStream("field_protected_obj.gif"));

    public static final int    PUBLIC          = 0;

    public static final int    PRIVATE         = 1;

    public static final int    PROTECTED       = 2;

    public void setSignature(String visibility, String returnType,
            String identifier) {
        this.setLabelAlignment(Label.LEFT);
        String txt = returnType + " " + identifier;
        setText(txt);
        setIcon(getVisibilityIcon(visibility));
    }

    public Dimension getMinimumSize(int w, int h) {
        return new Dimension(0, 0);
    }

    static public Image getVisibilityIcon(String visibility) {
        if (visibility.equals("public"))
            return IMAGE_PUBLIC;
        if (visibility.equals("private"))
            return IMAGE_PRIVATE;
        if (visibility.equals("protected"))
            return IMAGE_PROTECTED;
        return IMAGE_PUBLIC;

    }
}