package org.objectweb.jinha.figures;
 
import org.eclipse.draw2d.AbstractLabeledBorder;
import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.swt.graphics.Color;

/*
 * import java.awt.Color; import java.awt.Dimension; import java.awt.Graphics;
 * import java.awt.Insets; import java.awt.Point; import java.awt.Rectangle;
 * import org.eclipse.draw2d.AbstractLabeledBorder; import
 * org.eclipse.draw2d.FigureUtilities; import org.eclipse.draw2d.IFigure;
 */

public class ListFigureBorder extends AbstractLabeledBorder {

    private Color            color;

    private static final int BORDER_SIZE    = 2; //voir calculateInsets pour
                                                 // comprendre ce que c'est

    private static final int DECALAGE_LABEL = 5;

    private static final int MARGIN_SIZE    = 5;

    public void paint(IFigure f, Graphics g, Insets insetsFigure) {
        Rectangle area = f.getBounds().getCropped(insetsFigure);
        g.clipRect(area);

        //ligne:
        if (color != null) {
            g.setForegroundColor(color);
        }
        Point gauche = area.getLocation().translate(0,
                (getInsets(f).top - BORDER_SIZE) / 2);
        Point droit = gauche.getCopy().translate(area.width, 0);
        g.drawLine(gauche, droit);

        //marge:
        Color background = g.getBackgroundColor();
        if (color != null) {
            g.setBackgroundColor(color);
        }
        g.fillRectangle(area.x, droit.y, MARGIN_SIZE, area.height
                - (droit.y - area.y));
        g.setBackgroundColor(background);

        //label:
        Point coinSupGaucheText = area.getLocation().translate(
                DECALAGE_LABEL + MARGIN_SIZE, 0);
        g.fillString(getLabel(), coinSupGaucheText);
    }

    public void setColor(Color c) {
        color = c;
    }

    public Insets calculateInsets(IFigure f) {
        Dimension textSize = FigureUtilities.getTextExtents(getLabel(),
                getFont(f));
        int top = textSize.height + BORDER_SIZE;
        int left = MARGIN_SIZE + BORDER_SIZE;
        return new Insets(top, left, BORDER_SIZE, BORDER_SIZE);
    }
}