package org.objectweb.jinha.model;
 
import java.util.ArrayList;
import java.util.List;
import org.objectweb.jinha.model.emf.jinha.ModuleEjbDefinition;

/**
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class DiagramModel extends ObjectModel {
	private List elements;
    String moduleName=null;
    String projectName=null;
    ModuleEjbDefinition moduleEMF=null;
    
	
    
    // Reference vers le module EJB EMF
    //private ModuleEjbDefinition moduleEJB;
    
    
	public static final String PROPERTY_ELEMENT_ADDED = "class added";
	public static final String PROPERTY_ELEMENT_REMOVED = "class removed";
	
	/**
	 * 
	 */
	public DiagramModel()
  {
  	elements = new ArrayList();
   // ModelCreationFactory modelFactory = new ModelCreationFactory(ModuleEjbDefinition.class); 
    //moduleEJB = (ModuleEjbDefinition)modelFactory.getNewObject();
  moduleName="defaultEjbModule";
  }
	
	/**
	 * @return
	 */
	public List getElements()
	{
		return elements;
	}
	/**
	 * @param element
	 */
	public void addElement(DiagramElementModel element)
	{

		elements.add(element);
        //ajout de l'element au ModuleEjbDefinition, il faut tester le type d'element pour ajouter dans la bonne liste
		firePropertyChange(PROPERTY_ELEMENT_ADDED, null, element);
	}
	/**
	 * @param element
	 */
	public void removeElement(DiagramElementModel element)
	{
		elements.remove(element);
        //suppression de l'element au ModuleEjbDefinition, il faut tester le type d'element pour supprimer dans la bonne liste
		firePropertyChange(PROPERTY_ELEMENT_REMOVED, element, null);
	}
    /**
     * @return Returns the moduleName.
     */
    public String getModuleName() {
        return moduleName;
    }
    /**
     * @param moduleName The moduleName to set.
     */
    public void setModuleName(String name) {
        this.moduleName = name;
        
    }
    /**
     * @return Returns the projectName.
     */
    public String getProjectName() {
        return projectName;
    }
    /**
     * @param projectName The projectName to set.
     */
    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }
    /**
     * @return Returns the moduleEMF.
     */
    public ModuleEjbDefinition getModuleEMF() {
        return moduleEMF;
    }
    /**
     * @param moduleEMF The moduleEMF to set.
     */
    public void setModuleEMF(ModuleEjbDefinition moduleEMF) {
        this.moduleEMF = moduleEMF;
    }
}