package org.objectweb.jinha.model;

import java.util.Iterator;

import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.jface.dialogs.MessageDialog;
import org.objectweb.jinha.model.emf.jinha.GraphicalEJB;
import org.objectweb.jinha.model.emf.jinha.GraphicalEntity;
import org.objectweb.jinha.model.emf.jinha.GraphicalSession;
import org.objectweb.jinha.model.emf.jinha.JinhaFactory;
import org.objectweb.jinha.model.emf.jinha.JinhaPackage;
import org.objectweb.jinha.model.emf.jinha.ModuleEjbDefinition;

import com.objectlearn.lomboz.xml.lomboz.Attribute;
import com.objectlearn.lomboz.xml.lomboz.EntityBean;
import com.objectlearn.lomboz.xml.lomboz.FieldMapping;
import com.objectlearn.lomboz.xml.lomboz.LombozFactory;
import com.objectlearn.lomboz.xml.lomboz.LombozPackage;
import com.objectlearn.lomboz.xml.lomboz.SessionBean;
import com.sun.java.xml.ns.j2ee.CmpFieldType;
import com.sun.java.xml.ns.j2ee.CmpVersionType;
import com.sun.java.xml.ns.j2ee.CmrFieldType;
import com.sun.java.xml.ns.j2ee.CmrFieldTypeType;
import com.sun.java.xml.ns.j2ee.EjbClassType;
import com.sun.java.xml.ns.j2ee.EjbNameType;
import com.sun.java.xml.ns.j2ee.EntityBeanType;
import com.sun.java.xml.ns.j2ee.FullyQualifiedClassType;
import com.sun.java.xml.ns.j2ee.J2eeFactory;
import com.sun.java.xml.ns.j2ee.J2eePackage;
import com.sun.java.xml.ns.j2ee.JavaIdentifierType;
import com.sun.java.xml.ns.j2ee.JavaTypeType;
import com.sun.java.xml.ns.j2ee.MethodIntfType;
import com.sun.java.xml.ns.j2ee.MethodNameType;
import com.sun.java.xml.ns.j2ee.MethodParamsType;
import com.sun.java.xml.ns.j2ee.MethodType;
import com.sun.java.xml.ns.j2ee.PersistenceTypeType;
import com.sun.java.xml.ns.j2ee.QueryMethodType;
import com.sun.java.xml.ns.j2ee.SessionBeanType;
import com.sun.java.xml.ns.j2ee.SessionTypeType;
import com.sun.java.xml.ns.j2ee.TransactionTypeType;

/**
* This class implements the CreationFactory used by the CreationTool. It in
 * turn uses the EMF-generated factories to create the model instances

 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class ModelCreationFactory implements CreationFactory {


    private Class targetClass;
    private boolean isValidEditor=true;
    private  Resource res=null;
    
    private  JinhaPackage jinhaPackage = JinhaPackage.eINSTANCE;
    private  JinhaFactory jinhaFactory = jinhaPackage.getJinhaFactory();
    private  LombozPackage lombozPackage = LombozPackage.eINSTANCE;
    private  LombozFactory lombozFactory = lombozPackage.getLombozFactory();
    private  J2eePackage j2eePackage = J2eePackage.eINSTANCE;
    private  J2eeFactory j2eeFactory = j2eePackage.getJ2eeFactory();
    QueryMethodType query=j2eeFactory.createQueryMethodType();
    
    /**
     * @param targetClass
     *            the class we want instanciate
     */
    public ModelCreationFactory(Class targetClass, Resource r) {
        this.targetClass = targetClass;
        res=r;

    }
    
    

    /**
     * 
     */
    public ModelCreationFactory() {
        
    }
    
  

    /**
     * @return
     * @see org.eclipse.gef.requests.CreationFactory#getNewObject()
     */
    public Object getNewObject() {

 //if(res==null)
 //    res=EMFModelManager.getResource();
    	String Package=((ModuleEjbDefinition)res.getContents().get(0)).getName();
    	  	if(Package==null && isValidEditor==true){
    		MessageDialog dialog=new MessageDialog(null,"",null, "", MessageDialog.INFORMATION , new String[] {"close"}, 0);
    		dialog.openError(null,"Warning","This JINHa editor is not associated with a Lomboz module! It is going to be closed. You can open a new one with the Lomboz EJB module's contextual menu");
    		//dialog.open();
    		EMFModelManager.getPage().closeEditor(EMFModelManager.getEditor(),false);
    		isValidEditor=false;
    		return null;
    	  	}
        Object result = null;

        String ident=getIdent();
         if (targetClass.equals(SessionModel.class)) {
            result=new SessionModel(ident,res);
          
            AttributeModel attribute1 = new AttributeModel("private","javax.ejb.SessionContext","sessionContext");        
            attribute1.setAttribute(createJavaAttribute("private","javax.ejb.SessionContext","sessionContext"));
            ((SessionModel)result).getAttributeList().addElement(attribute1);
           ((GraphicalSession)((SessionModel)result).getGraphicalEjb()).getSessionBean().getJavaAttributes().add(attribute1.getAttribute());
            
            HomeMethodModel ejbCreateMethod = new HomeMethodModel(res,"public","void","setSessionContext","javax.ejb.SessionContext sessionContext");
            ejbCreateMethod.setMethod(CreateMethod(home,"public","void","setSessionContext",new String[][] {{"javax.ejb.SessionContext", "sessionContext"}}));
            ((SessionModel)result).getHomeMethods().addElement(ejbCreateMethod);
            ((GraphicalSession)((SessionModel)result).getGraphicalEjb()).getSessionBean().getMethods().add(ejbCreateMethod.getMethod());

        }
         else if(targetClass.equals(GraphicalSession.class)) {
             
             Package=Package.substring(Package.lastIndexOf(".")+1);
             result=createGraphicalSession(ident,Package+"."+ident,"stateful","container");
             ((GraphicalEJB)result).setId(((GraphicalSession)result).getSessionBean().getSessionEjb().getEjbClass().getValue());

         }
        else if (targetClass.equals(EntityModel.class)) {
            result=new EntityModel(ident,res);
           
            AttributeModel attribute1 = new AttributeModel("private","javax.ejb.EntityContext","entityContext");
            attribute1.setAttribute(createJavaAttribute("private","javax.ejb.EntityContext","entityContext"));
            ((EntityModel)result).getAttributeList().addElement(attribute1);
            ((GraphicalEntity)((EntityModel)result).getGraphicalEjb()).getEntityBean().getJavaAttributes().add(attribute1.getAttribute());
            // TODO Move this field into a CMP PK Field
            
            
            HomeMethodModel setEntityContextMethod = new HomeMethodModel(res,"public","void","setEntityContext","javax.ejb.EntityContext entityContext");
            ((EntityModel)result).getHomeMethods().addElement(setEntityContextMethod);
            setEntityContextMethod.setMethod(CreateMethod(home,"public","void","setEntityContext",new String[][] {{"javax.ejb.EntityContext", "entityContext"}}));
            ((GraphicalEntity)((EntityModel)result).getGraphicalEjb()).getEntityBean().getMethods().add(setEntityContextMethod.getMethod());
            
            HomeMethodModel unSetEntityContextMethod = new HomeMethodModel(res,"public","void","unSetEntityContext","");
            ((EntityModel)result).getHomeMethods().addElement(unSetEntityContextMethod);
            unSetEntityContextMethod.setMethod(CreateMethod(home,"public","void","unSetEntityContext",new String[0][0]));
            ((GraphicalEntity)((EntityModel)result).getGraphicalEjb()).getEntityBean().getMethods().add(unSetEntityContextMethod.getMethod());
            
            HomeMethodModel findByPKMethod = new HomeMethodModel(res,"public","void","findByPK","");
            ((EntityModel)result).getHomeMethods().addElement(findByPKMethod);
            findByPKMethod.setMethod(CreateMethod(home,"public","void","findByPK",new String[0][0]));
            ((GraphicalEntity)((EntityModel)result).getGraphicalEjb()).getEntityBean().getMethods().add(findByPKMethod.getMethod());
           
          
            CMPModel cmp=new CMPModel(res);
            cmp.setPrimaryKey(true);
            ((EntityModel)result).getCMPs().addElement(cmp);
            ((GraphicalEntity)((EntityModel)result).getGraphicalEjb()).getEntityBean().getFieldMappings().add(cmp.getFieldMapping());
            
        }
        else if (targetClass.equals(GraphicalEntity.class)) {

            Package=Package.substring(Package.lastIndexOf(".")+1);
            result=createGraphicalEntity(ident,Package+"."+ident ,"Container","Container");
            
            ((GraphicalEJB)result).setId(Package+"."+ident);

        }
        else if (targetClass.equals(MessageDrivenModel.class)) {
            result=new MessageDrivenModel();

        }

        else if (targetClass.equals(AttributeModel.class)) {
            result=new  AttributeModel("",res);

        }
        else if (targetClass.equals(Attribute.class)) {
            result=createJavaAttribute("private","int","untitledAttribute");

        }
        else if (targetClass.equals(BusinessMethodModel.class)) {
            result=new BusinessMethodModel(res);
            ((BusinessMethodModel)result).getMethod().getMethodIntf().setValue("Remote");

        }
        else if (targetClass.equals(HomeMethodModel.class)) {
            result=new HomeMethodModel(res);
            

        }
        else if(targetClass.equals(MethodType.class)) {
            result=CreateMethod("Home","public","void","untitledMethod",new String[0][0]);    
        }
        else if (targetClass.equals(FinderModel.class)) {
            result=new FinderModel(res);

        }
        else if (targetClass.equals(CMPModel.class)) {
            result=new CMPModel(res);

        }
        else if (targetClass.equals(FieldMapping.class)) {
            result=createCMPField("PK_FIELD","java.lang.String","ID","VARCHAR","VARCHAR(100)");

        }
        else if (targetClass.equals(CMRModel.class)) {
            result=new CMRModel(res);

        }
        else if (targetClass.equals(CmrFieldType.class)) {
            result=createCMR("cmr","java.util.Collection");

        }
        else if (targetClass.equals(RelationModel.class)) {
            result=new RelationModel(res);

        }
        else if (targetClass.equals(JavaTypeType.class)) {
            result=j2eeFactory.createJavaTypeType();
            
        }
        else if (targetClass.equals(JavaIdentifierType.class)) {
            result=j2eeFactory.createJavaIdentifierType();
            
        }
        return result;
    }

   
    /**
     * @return
     * @see org.eclipse.gef.requests.CreationFactory#getObjectType()
     */
    public Object getObjectType() {
        return targetClass;
    }

    
    /**
     * @param name
     * @param typ
     * @return
     */
    public CmrFieldType createCMR(String name,
                                  String typ) {
        CmrFieldType cmrFieldType=j2eeFactory.createCmrFieldType();
        com.sun.java.xml.ns.j2ee.String nam=j2eeFactory.createString();

        cmrFieldType.setCmrFieldName(nam);

        nam.setValue(name);
        CmrFieldTypeType type=j2eeFactory.createCmrFieldTypeType();

        type.setValue(typ);
        cmrFieldType.setCmrFieldType(type);

        return cmrFieldType;
    }
    /**
     * @return
     */
    public GraphicalEntity createGraphicalEntity(String name, String nameClass, String type, String transaction) {
       GraphicalEntity graphicalEntity=jinhaFactory.createGraphicalEntity();

       EntityBean entityBean=lombozFactory.createEntityBean();
       entityBean.setDataSourceName("MY_CMP_BEAN_TBL");
       entityBean.setTableName("MY_JDBC_DATASOURCE");
       graphicalEntity.setEntityBean(entityBean); 
       
       EntityBeanType entityBeanType=j2eeFactory.createEntityBeanType();
       com.sun.java.xml.ns.j2ee.String primaryKey = j2eeFactory.createString();
		primaryKey.setValue("PK_FIELD");
		entityBeanType.setPrimkeyField(primaryKey);
		FullyQualifiedClassType primaryKeyClass = j2eeFactory.createFullyQualifiedClassType();
		primaryKeyClass.setValue("java.lang.String");
		entityBeanType.setPrimKeyClass(primaryKeyClass);

		JavaIdentifierType schema = j2eeFactory.createJavaIdentifierType();
		schema.setValue("MYSCHEMA");
		entityBeanType.setAbstractSchemaName(schema);
		
		
		CmpVersionType cmpVersion = j2eeFactory.createCmpVersionType();
		cmpVersion.setValue("2.x");
		entityBeanType.setCmpVersion(cmpVersion);
       
       entityBean.setEntityEjb(entityBeanType);
       
       PersistenceTypeType persistenceType = j2eeFactory.createPersistenceTypeType();
		persistenceType.setValue("Container");
		entityBeanType.setPersistenceType(persistenceType);
       
       
       EjbClassType ejbClassType=j2eeFactory.createEjbClassType();
       ejbClassType.setValue(nameClass);

       entityBean.getEntityEjb().setEjbClass(ejbClassType);
       
       
       EjbNameType ejbNameType=j2eeFactory.createEjbNameType();

       ejbNameType.setValue(name);
       entityBean.getEntityEjb().setEjbName(ejbNameType);
       
        return graphicalEntity;
    }
    
/**
 * @return
 */
public  GraphicalSession createGraphicalSession(String name, String nameClass, String type, String transaction) {
    GraphicalSession graphicalSession = jinhaFactory.createGraphicalSession();

    graphicalSession.setHeight(50);
    graphicalSession.setWidth(50);
    
    
    SessionBean lsessionBean = lombozFactory.createSessionBean();

    graphicalSession.setSessionBean(lsessionBean);
    SessionBeanType sessionBean = j2eeFactory.createSessionBeanType();
    lsessionBean.setSessionEjb(sessionBean);
    EjbNameType ejbNameType=j2eeFactory.createEjbNameType();
    ejbNameType.setValue(name);
    sessionBean.setEjbName(ejbNameType);

    EjbClassType ejbClassType=j2eeFactory.createEjbClassType();

    sessionBean.setEjbClass(ejbClassType);
    sessionBean.getEjbClass().setValue(nameClass);
    SessionTypeType sessionTypeType=j2eeFactory.createSessionTypeType();

    sessionBean.setSessionType(sessionTypeType);
    sessionBean.getSessionType().setValue(type);
    TransactionTypeType transactionTypeType=j2eeFactory.createTransactionTypeType();

    sessionBean.setTransactionType(transactionTypeType);
    sessionBean.getTransactionType().setValue(transaction);
   
    return graphicalSession;
}


private String remote="Remote";
private String local="Local";
private String both="Both";
private String localHome="LocalHome";
private String home="Home";

    /**
     * @param viewType
     * @param accessibility
     * @param returnType
     * @param name
     * @param params
     * @return
     */
    public   MethodType CreateMethod(String viewType,
                                     String accessibility,
                                     String returnType,
                                     String name,
                                     String[][] params/*moduleName,type*/) {
           

                     MethodType method = j2eeFactory.createMethodType();

                     MethodParamsType methodParamsType = j2eeFactory.createMethodParamsType();

                     method.setMethodParams(methodParamsType);
                     MethodIntfType view=j2eeFactory.createMethodIntfType();

                    if(viewType.equals("Remote") || viewType.equals("Local") || viewType.equals("Both") || viewType.equals("LocalHome") || viewType.equals("Home"))
                        view.setValue(viewType);
                    else view.setValue("Remote");
                    method.setMethodIntf(view);
                     MethodNameType methodName = j2eeFactory.createMethodNameType();

   
                     methodName.setId(returnType);
                     methodName.setValue(name);
                     method.setMethodName(methodName);
             
                     for(int i=0;i<params.length;i++) {
                     JavaTypeType type = j2eeFactory.createJavaTypeType();

                     type.setId(params[i][1]);
                     type.setValue(params[i][0]);
                     methodParamsType.getMethodParam().add(type);
                     }
                     return method;
         }

    
    
         /**
         * @param visibility
         * @param type
         * @param name
         * @return
         */
        public   Attribute createJavaAttribute(String visibility,
                                                String type,
                                                String name) {
            
                    Attribute attribute1 = lombozFactory.createAttribute();

                    JavaTypeType javatypetype = j2eeFactory.createJavaTypeType();

                    javatypetype.setValue(type);
                    JavaIdentifierType javaIdentifierType = j2eeFactory.createJavaIdentifierType(); 

                    
                    javaIdentifierType.setValue(name);
                    attribute1.setName(javaIdentifierType);
                    attribute1.setType(javatypetype);
                    attribute1.setVisibility(j2eeFactory.createString());

                    attribute1.getVisibility().setValue(visibility);
                    return attribute1;
         }
         
        /**
         * @param fieldNam
         * @param fieldTyp
         * @param columnNam
         * @param jdbcTyp
         * @param sqlTyp
         * @return
         */
        public FieldMapping  createCMPField(String fieldNam,
                                            String fieldTyp,
                                            String columnNam,
                                            String jdbcTyp,
                                            String sqlTyp
                                            
                                            ) {
            CmpFieldType cmpField = j2eeFactory.createCmpFieldType();

      
            JavaIdentifierType fieldName = j2eeFactory.createJavaIdentifierType();

            fieldName.setValue(fieldNam);
            FullyQualifiedClassType fieldType = j2eeFactory.createFullyQualifiedClassType();

            fieldType.setValue(fieldTyp);
            JavaIdentifierType columnName = j2eeFactory.createJavaIdentifierType();

            columnName.setValue(columnNam);
            //      ARRAY BIGINT BINARY BIT BLOB BOOLEAN CHAR CLOB  DATALINK
            //      DATE DECIMAL DISTINCT DOUBLE FLOAT INTEGER JAVA_OBJECT LONGVARBINARY
            //      LONGVARCHAR NULL NUMERIC OTHER REAL REF SMALLINT STRUCT TIME TIMESTAMP
            //      TINYINT VARBINARY VARCHAR
            JavaIdentifierType jdbcType = j2eeFactory.createJavaIdentifierType();

            jdbcType.setValue(jdbcTyp);
            JavaIdentifierType  sqlType = j2eeFactory.createJavaIdentifierType();

            sqlType.setValue(sqlTyp);
            
            cmpField.setFieldName(fieldName);
            FieldMapping fieldMapping = lombozFactory.createFieldMapping();


            fieldMapping.setReadOnly(false);
            fieldMapping.setPrimaryKey(false);
            fieldMapping.setFieldName(fieldName);
            fieldMapping.setFieldType(fieldType);
            fieldMapping.setColumnName(columnName);
            fieldMapping.setJdbcType(jdbcType);
            fieldMapping.setSqlType(sqlType);   
            return fieldMapping;
        }

    /**
     * @return Returns the targetClass.
     */
    public Class getTargetClass() {
        return targetClass;
    }
    /**
     * @param targetClass The targetClass to set.
     */
    public void setTargetClass(Class targetClass) {
        this.targetClass = targetClass;
    }
    /**
     * @return Returns the res.
     */
    public  Resource getRes() {
        return res;
    }
    /**
     * @param res The res to set.
     */
    public  void setRes(Resource res) {
       
            this.res = res;
    }

    /**
     * @return Returns the entityCount.
     */
    public int getEntityCount() {
        return ((ModuleEjbDefinition)res.getContents().get(0)).getGraphicalEntityBeans().size()+1;
    }

    /**
     * @return Returns the sessionCount.
     */
    public int getSessionCount() {
        return ((ModuleEjbDefinition)res.getContents().get(0)).getGraphicalSessionBeans().size()+1;
    }
    /**
	 * @return
	 */
	private String getIdent() {
		String id=null;

		if(targetClass.equals(SessionModel.class) || targetClass.equals(GraphicalSession.class)){
		id="Session"+getSessionCount();
		Iterator it=((ModuleEjbDefinition)res.getContents().get(0)).getGraphicalSessionBeans().iterator();
		while(it.hasNext()){
			if(id.equals(((GraphicalSession)it.next()).getSessionBean().getSessionEjb().getEjbName().getValue())){
				id+="_"+getSessionCount();
				it=((ModuleEjbDefinition)res.getContents().get(0)).getGraphicalSessionBeans().iterator();
			}
		}
}
		else if(targetClass.equals(EntityModel.class) || targetClass.equals(GraphicalEntity.class)){
			id="Entity"+getEntityCount();
			Iterator it=((ModuleEjbDefinition)res.getContents().get(0)).getGraphicalEntityBeans().iterator();
			while(it.hasNext()){
				if(id.equals(((GraphicalEntity)it.next()).getEntityBean().getEntityEjb().getEjbName().getValue())){
					id+="_"+getEntityCount();
					it=((ModuleEjbDefinition)res.getContents().get(0)).getGraphicalEntityBeans().iterator();
				}
			}
	}

	return id;	
	}
}

