/*
 * Created on 24 sept. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.objectweb.jinha.model.properties;

import java.util.ArrayList;

import org.eclipse.ui.views.properties.ComboBoxPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;
import org.objectweb.jinha.model.ObjectModel;

import com.objectlearn.j2ee.gmf.core.EjbConstants;
import com.objectlearn.lomboz.xml.lomboz.FieldMapping;


/**
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
 */
public class PropertyCmpPersistence extends ObjectModel {

    private String columnName;
    private String jdbcType;
    private String sqlType;
    private String readOnly;
    
    private FieldMapping fieldMapping;
    private IPropertyDescriptor descriptors[];
    
    private static final String ID_PROPERTY_CMP_COLUMN_NAME = "column-name";
    private static final String ID_PROPERTY_CMP_JDBC_TYPE = "jdbc-type";
    private static final String ID_PROPERTY_CMP_SQL_TYPE = "sql-type";
    private static final String ID_PROPERTY_CMP_READ_ONLY = "read-only";
    
    private static ArrayList jdbcConstants;
    
    /**
     * @param jonasJndiName
     */
    public PropertyCmpPersistence(FieldMapping fieldMapping) {
        
        this.fieldMapping = fieldMapping;
        descriptors = (new IPropertyDescriptor[] {
                new TextPropertyDescriptor(ID_PROPERTY_CMP_COLUMN_NAME, ID_PROPERTY_CMP_COLUMN_NAME),
                new ComboBoxPropertyDescriptor(ID_PROPERTY_CMP_JDBC_TYPE, ID_PROPERTY_CMP_JDBC_TYPE,getJDBCConstants()),
                new TextPropertyDescriptor(ID_PROPERTY_CMP_SQL_TYPE, ID_PROPERTY_CMP_SQL_TYPE),
                new ComboBoxPropertyDescriptor(ID_PROPERTY_CMP_READ_ONLY, ID_PROPERTY_CMP_READ_ONLY,new String[] { "true", "false" })
                
        });
        // init the JDBC Type value into an array from Lomboz
        initArray();
        
        // Set EMF Values
        setColumnName("columnName");
        setJdbcType((String)jdbcConstants.get(0));
        setSqlType("VARCHAR");
        setReadOnly("false");
        
        
    }
    
    /**
     * @return
     * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyDescriptors()
     */
    public IPropertyDescriptor[] getPropertyDescriptors() {
        
        return descriptors;
    }
    /**
     * @param propName
     * @return
     * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyValue(java.lang.Object)
     */
    public Object getPropertyValue(Object propName) {
        // TODO Auto-generated method stub
        if (propName instanceof String) {
            if (((String) propName).equals(ID_PROPERTY_CMP_COLUMN_NAME))
                return getColumnName();
            else if (((String) propName).equals(ID_PROPERTY_CMP_JDBC_TYPE))
            {
               
               return new Integer(jdbcConstants.indexOf(getJdbcType()));
               
            }
            else if (((String) propName).equals(ID_PROPERTY_CMP_SQL_TYPE))
                return getSqlType();
            else if (((String) propName).equals(ID_PROPERTY_CMP_READ_ONLY))
            {
                if(getReadOnly().equals("true"))
                    return new Integer(0);
                else
                    return new Integer(1);
            }
        }
        
        return super.getPropertyValue(propName);
    }
    /**
     * @param propName
     * @param val
     * @see org.eclipse.ui.views.properties.IPropertySource#setPropertyValue(java.lang.Object, java.lang.Object)
     */
    public void setPropertyValue(Object propName, Object val) {
        // TODO Auto-generated method stub
        if (propName instanceof String) {
            if (((String) propName).equals(ID_PROPERTY_CMP_COLUMN_NAME))
                setColumnName((String) val);
            else if (((String) propName).equals(ID_PROPERTY_CMP_JDBC_TYPE))
                setJdbcType((String)jdbcConstants.get(((Integer) val).intValue()));
            else if (((String) propName).equals(ID_PROPERTY_CMP_SQL_TYPE))
                setSqlType((String) val);
            else if (((String) propName).equals(ID_PROPERTY_CMP_READ_ONLY))
            {  if (((Integer) val).intValue() == 0)
                    setReadOnly("true");
                else if (((Integer) val).intValue() == 1)
                    setReadOnly("false");
            }
        }
        else 
            super.setPropertyValue(propName, val);
    }
    
    
    
    /**
     * @return
     * @see java.lang.Object#toString()
     */
    public String toString() {
        // TODO Auto-generated method stub
        return "Persistence fields for CMP";
    }
    /**
     * @return Returns the columnName.
     */
    public String getColumnName() {
        return columnName;
    }
    /**
     * @param columnName The columnName to set.
     */
    public void setColumnName(String columnName) {
        this.columnName = columnName;
//      EMF part
        fieldMapping.getColumnName().setValue(this.columnName);
    }
    /**
     * @return Returns the jdbcType.
     */
    public String getJdbcType() {
        return jdbcType;
    }
    /**
     * @param jdbcType The jdbcType to set.
     */
    public void setJdbcType(String jdbcType) {
        this.jdbcType = jdbcType;
        
//      EMF part
        fieldMapping.getJdbcType().setValue(this.jdbcType);
    }
    /**
     * @return Returns the readOnly.
     */
    public String getReadOnly() {
        return readOnly;
    }
    /**
     * @param readOnly The readOnly to set.
     */
    public void setReadOnly(String readOnly) {
        this.readOnly = readOnly;
        
        // EMF part
        fieldMapping.setReadOnly(new Boolean(readOnly).booleanValue());
    }
    /**
     * @return Returns the sqlType.
     */
    public String getSqlType() {
        return sqlType;
    }
    /**
     * @param sqlType The sqlType to set.
     */
    public void setSqlType(String sqlType) {
        this.sqlType = sqlType;
        
        // EMF part
        fieldMapping.getSqlType().setValue(this.sqlType);
    }
    
    public void initArray() {
        jdbcConstants  = new ArrayList(EjbConstants.LABEL_JDBCTYPES.length);
        
        for(int i=0;i<EjbConstants.LABEL_JDBCTYPES.length;i++)
            jdbcConstants.add(EjbConstants.LABEL_JDBCTYPES[i]);
    }
    
    public static String[] getJDBCConstants() {
        // link with Lomboz constants definition
                
        return EjbConstants.LABEL_JDBCTYPES;
    }
}
