package org.objectweb.jinha.testing;

import java.util.ArrayList;
import java.util.List;
import org.objectweb.jinha.model.emf.jinha.GraphicalEntity;
import org.objectweb.jinha.model.emf.jinha.GraphicalMessageDriven;
import org.objectweb.jinha.model.emf.jinha.GraphicalSession;
import org.objectweb.jinha.model.emf.jinha.JinhaFactory;
import org.objectweb.jinha.model.emf.jinha.JinhaPackage;
import org.objectweb.jinha.model.emf.jinha.ModuleEjbDefinition;
import org.objectweb.jinha.testing.junit.testEntityCreate;
import org.objectweb.jinha.testing.junit.testSessionCreate;
import com.objectlearn.lomboz.xml.lomboz.DocumentRoot;
import com.objectlearn.lomboz.xml.lomboz.EjbDefinition;
import com.objectlearn.lomboz.xml.lomboz.EntityBean;
import com.objectlearn.lomboz.xml.lomboz.LombozFactory;
import com.objectlearn.lomboz.xml.lomboz.LombozPackage;
import com.objectlearn.lomboz.xml.lomboz.MessageDrivenBean;
import com.objectlearn.lomboz.xml.lomboz.SessionBean;
import com.sun.java.xml.ns.j2ee.J2eeFactory;
import com.sun.java.xml.ns.j2ee.J2eePackage;


/**
 * this class permit to testing the file methodStub.javajet for an Entity
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
 */
public class testModuleEjbDefinition {
    
    protected JinhaPackage jinhaPackage = JinhaPackage.eINSTANCE;

    protected JinhaFactory jinhaFactory = jinhaPackage.getJinhaFactory();

    protected J2eePackage j2eePackage = J2eePackage.eINSTANCE;

    protected J2eeFactory j2eeFactory = j2eePackage.getJ2eeFactory();

    protected LombozPackage lombozPackage = LombozPackage.eINSTANCE;

    protected LombozFactory lombozFactory = lombozPackage.getLombozFactory();
    
    
    
    /**
     * Creation of an ModuleEjbDefinition for testing
     * @return an instance of a ModuleEjbDefinition 
     */
    public ModuleEjbDefinition createModule(){
    
        ModuleEjbDefinition module = jinhaFactory.createModuleEjbDefinition();
        // cration d'une liste de GraphicalSession
        testSessionCreate session = new testSessionCreate();
        module.getGraphicalSessionBeans().add(session.createGraphicalSession("essai","pack.essai"));
        //module.getGraphicalSessionBeans().add(session.createGraphicalSession("ejbname2","pack.ejbname2"));
        testEntityCreate entity = new testEntityCreate();
        entity.TestRelation(module);
        return module;
   }
    
    /**
     * This function convert a ModuleEjbDefinition to a list DocumentRoot  
     * @param module : the ModuleEjbDefinition to convert
     * @return the list of DocumentRoot 
     */
    public List ModuleToListDocumentRoot(ModuleEjbDefinition module){
        List rootObject = new ArrayList();
        int i=0;
        
        for(i=0;i<module.getGraphicalEntityBeans().size();i++){
            GraphicalEntity graphicalEntity = (GraphicalEntity) module.getGraphicalEntityBeans().get(i);
            EntityBean entityBean = graphicalEntity.getEntityBean();
            EjbDefinition ejbDefinition = lombozFactory.createEjbDefinition();
            ejbDefinition.setEntity(entityBean);
            DocumentRoot documentRoot = lombozFactory.createDocumentRoot();
            documentRoot.setEjb(ejbDefinition);
            rootObject.add(documentRoot);
        }
        for(i=0;i<module.getGraphicalSessionBeans().size();i++){
            GraphicalSession graphicalSession = (GraphicalSession) module.getGraphicalSessionBeans().get(i);
            SessionBean sessionBean = graphicalSession.getSessionBean();
            EjbDefinition ejbDefinition = lombozFactory.createEjbDefinition();
            ejbDefinition.setSession(sessionBean);
            DocumentRoot documentRoot = lombozFactory.createDocumentRoot();
            documentRoot.setEjb(ejbDefinition);
            rootObject.add(documentRoot);
        }
        for(i=0;i<module.getGraphicalMessageDrivenBeans().size();i++){
            GraphicalMessageDriven graphicalMessageDriven = (GraphicalMessageDriven) module.getGraphicalMessageDrivenBeans().get(i);
            MessageDrivenBean messageDrivenBean = graphicalMessageDriven.getMessageDrivenBean();
            EjbDefinition ejbDefinition = lombozFactory.createEjbDefinition();
            ejbDefinition.setMessageDriven(messageDrivenBean);
            DocumentRoot documentRoot = lombozFactory.createDocumentRoot();
            documentRoot.setEjb(ejbDefinition);
            rootObject.add(documentRoot);
        }
        return rootObject;
    }
}